Package cds.healpix.fillingcurve

# Class ZOrderCurve2DImpls

java.lang.Object
cds.healpix.fillingcurve.ZOrderCurve2DImpls

public final class ZOrderCurve2DImpls extends Object
Utility class containing several implementations of the z-order curve in two dimension. All implementations implement the `FillingCurve2D` interface.

Author:
  F.-X. Pineau

## Field Summary

Fields
Modifier and Type
Field
Description
`static final FillingCurve2D`
`EMPTY`
Implementation doing nothing (all methods return 0).
`static final FillingCurve2D`
`ZOC_VMSB_LOOKUP_BYTE`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_LOOKUP_INT`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_LOOKUP_SHORT`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_OR_BYTE`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_OR_INT`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_OR_SHORT`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_XOR_BYTE`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_XOR_INT`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).
`static final FillingCurve2D`
`ZOC_VMSB_XOR_SHORT`
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB).

## Method Summary

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### EMPTY

public static final FillingCurve2D EMPTY
Implementation doing nothing (all methods return 0).

### ZOC_VMSB_OR_BYTE

public static final FillingCurve2D ZOC_VMSB_OR_BYTE
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on the bitwise OR operator to interleave the bits of the discretized 2d-coordinates. We assume that each discritized coordinates is coded on maximum 8 bits (BYTE). The algorithm is a slightly adapted version of the outer perfect shuffle define p. 106 of "Hacker's Delight" (Henry S. Warren, Jr), slightly modified.

### ZOC_VMSB_OR_SHORT

public static final FillingCurve2D ZOC_VMSB_OR_SHORT
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on the bitwise OR operator to interleave the bits of the discretized 2d-coordinates. We assume that each discritized coordinates is coded on maximum 16 bits (SHORT). The algorithm is a slightly adapted version of the outer perfect shuffle define p. 106 of "Hacker's Delight" (Henry S. Warren, Jr), slightly modified.

### ZOC_VMSB_OR_INT

public static final FillingCurve2D ZOC_VMSB_OR_INT
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on the bitwise OR operator to interleave the bits of the discretized 2d-coordinates. We assume that each discritized coordinates is coded on maximum 32 bits. The algorithm is a slightly adapted and extended version of the outer perfect shuffle define p. 106 of "Hacker's Delight" (Henry S. Warren, Jr).

### ZOC_VMSB_XOR_BYTE

public static final FillingCurve2D ZOC_VMSB_XOR_BYTE
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on the bitwise XOR operator to interleave the bits of the discretized 2d-coordinates. We assume that each discritized coordinates is coded on maximum 8 bits (BYTE). The algorithm is a slightly adapted version of the outer perfect shuffle define p. 106 of "Hacker's Delight" (Henry S. Warren, Jr), slightly modified.

### ZOC_VMSB_XOR_SHORT

public static final FillingCurve2D ZOC_VMSB_XOR_SHORT
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on the bitwise XOR operator to interleave the bits of the discretized 2d-coordinates. We assume that each discritized coordinates is coded on maximum 16 bits (SHORT). The algorithm is a slightly adapted version of the outer perfect shuffle define p. 106 of "Hacker's Delight" (Henry S. Warren, Jr).

### ZOC_VMSB_XOR_INT

public static final FillingCurve2D ZOC_VMSB_XOR_INT
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on the bitwise XOR operator to interleave the bits of the discretized 2d-coordinates. We assume that each discritized coordinates is coded on maximum 32 bits (INT). The algorithm is a slightly adapted version of the outer perfect shuffle define p. 106 of "Hacker's Delight" (Henry S. Warren, Jr), slightly modified.

### ZOC_VMSB_LOOKUP_BYTE

public static final FillingCurve2D ZOC_VMSB_LOOKUP_BYTE
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on a lookup table (LOOKUP). We assume that each discritized coordinates is coded on maximum 8 bits (BYTE).

### ZOC_VMSB_LOOKUP_SHORT

public static final FillingCurve2D ZOC_VMSB_LOOKUP_SHORT
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on a lookup table (LOOKUP). We assume that each discritized coordinates is coded on maximum 16 bits (SHORT).

### ZOC_VMSB_LOOKUP_INT

public static final FillingCurve2D ZOC_VMSB_LOOKUP_INT
Z-Order Curve (ZOC) implementation in which the vertical coordinate carry the most significant bit (VMSB). This implementation is based on a lookup table (LOOKUP). We assume that each discritized coordinates is coded on maximum 32 bits (INT).